--- grml-live.orig	2009-11-23 16:23:28.146515017 +0100
+++ grml-live.new	2009-11-23 17:09:57.756877216 +0100
@@ -53,6 +53,7 @@
    -n                      skip generation of ISO
    -o <output_directory>   main output directory of the build process
    -q                      skip mksquashfs
+   -p                      generate list of installed packages
    -r <release_name>       release name
    -s <suite>              Debian suite; values: etch, lenny, squeeze, sid
    -t <template_directory> place of the templates
@@ -212,7 +213,7 @@
 # }}}
 
 # command line parsing {{{
-while getopts "a:C:c:d:g:i:I:o:r:s:t:v:bBFnquVz" opt; do
+while getopts "a:C:c:d:g:i:I:o:r:s:t:v:bBFnpquVz" opt; do
   case "$opt" in
     a) ARCH="$OPTARG" ;;
     b) BUILD_ONLY=1 ;;
@@ -225,6 +226,7 @@
     I) CHROOT_INSTALL="$OPTARG" ;;
     n) SKIP_MKISOFS=1 ;;
     o) OUTPUT="$OPTARG" ;;
+    p) GEN_PKGS_LIST=1 ;;
     q) SKIP_MKSQUASHFS=1 ;;
     r) RELEASENAME="$OPTARG" ;;
     s) SUITE="$OPTARG" ;;
@@ -334,6 +336,7 @@
    [ -n "$UPDATE" ]             && echo "  Executing UPDATE instead of fresh installation."
    [ -n "$SKIP_MKSQUASHFS" ]    && echo "  Skipping creation of SQUASHFS file."
    [ -n "$SKIP_MKISOFS" ]       && echo "  Skipping creation of ISO file."
+   [ -n "$GEN_PKGS_LIST" ]      && echo "  Generating list of installed packages."
    [ -n "$BUILD_ONLY" ]         && echo "  Executing BUILD_ONLY instead of fresh installation or UPDATE."
    [ -n "$BUILD_DIRTY" ]        && echo "  Executing BUILD_DIRTY to leave chroot untouched."
    echo
@@ -1080,6 +1083,10 @@
       esac
 
       cd $CURRENT_DIR
+
+      # generate list of packages if '-p' option specified
+      [ -n "$GEN_PKGS_LIST" ] && dpkg --root=${CHROOT_OUTPUT} -l > ${ISO_OUTPUT}/${ISO_NAME}.pkgs && \
+        touch -r ${ISO_OUTPUT}/${ISO_NAME} ${ISO_OUTPUT}/${ISO_NAME}.pkgs
    fi
 
    if [ "$RC" = 0 ] ; then
